/*
 * Copyright (C) 2016 UMR AMAP (botAnique et Modélisation de l'Architecture des Plantes et des végétations.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301  USA
 */
package fr.amap.amapvox.io.tls.rsp;

import java.util.ArrayList;
import java.util.List;
import javax.vecmath.Matrix4d;

/**
 *
 * @author Julien Heurtebize (julienhtbe@gmail.com)
 */
public class Scans {
    
    private String name;
    private String fold;
    private Matrix4d sopMatrix;
    private final List<RxpScan> rxpScans;
    
    
    public Scans(){
        sopMatrix = new Matrix4d();
        sopMatrix.setIdentity();
        rxpScans = new ArrayList();
    }

    public void setFold(String fold) {
        this.fold = fold;
    }
    
    public void setSopMatrix(Matrix4d sopMatrix) {
        this.sopMatrix = sopMatrix;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public void addScan(RxpScan rxpScan) {
        rxpScans.add(rxpScan);
    }

    public String getName() {
        return name;
    }

    public String getFold() {
        return fold;
    }

    public Matrix4d getSopMatrix() {
        return sopMatrix;
    }

    public List<RxpScan> getScans() {
        return rxpScans;
    }
}
